FUNCTION drz_polygons_inter,i_tr1,j_tr1,i_tr2,j_tr2,tr1_in_tr2,tr2_in_tr1,ipol,jpol,plot_it=plot_it,count=count,order=order,double=double

;compute surface of intersection between two convex polygones of the same type
;Not optimal, but simple to implement
;result ok only if /order is used

Ntr=n_elements(i_tr1)
vvec=[lindgen(Ntr),lindgen(Ntr),lindgen(Ntr)]

IF keyword_set(plot_it) THEN BEGIN
  loadct,13
  all_i=[i_tr1,i_tr2] & all_j=[j_tr1,j_tr2]
  plot,[i_tr1,i_tr1(0)],[j_tr1,j_tr1(0)],psym=-4,/ysty,xrange=minmax(all_i),yrange=minmax(all_j),/xsty
  oplot,[i_tr2,i_tr2(0)],[j_tr2,j_tr2(0)],psym=-4,color=100
ENDIF

;This could be done externally
;compute which points of tr1 are inside tr2
;tr1_in_tr2=inside(i_tr1, j_tr1, i_tr2, j_tr2)
ind12=where(tr1_in_tr2 EQ 1,count12,complement=ind12_not)
;tr2_in_tr1=inside(i_tr2, j_tr2, i_tr1, j_tr1)
ind21=where(tr2_in_tr1 EQ 1,count21,complement=ind21_not)

;print,'count12=',count12,'count21=',count21

Nmax=Ntr*Ntr
ipol=fltarr(Nmax)+!drz_undef
jpol=fltarr(Nmax)+!drz_undef
count=0
ii_from_2=-1
ii_from_1=-1
FOR jj=0L,Ntr-1 DO BEGIN
;  ii_from_2=(ii_from_2+1) mod Ntr
;  ii_to_2=(ii_from_2+1) mod Ntr
  ii_from_2=vvec(ii_from_2+1)
  ii_to_2=vvec(ii_from_2+1)
  FOR kk=0L,Ntr-1 DO BEGIN
;    ii_from_1=(ii_from_1+1) mod Ntr
;    ii_to_1=(ii_from_1+1) mod Ntr
    ii_from_1=vvec(ii_from_1+1)
    ii_to_1=vvec(ii_from_1+1)
    inter=inter_segments(i_tr1(ii_from_1),j_tr1(ii_from_1),i_tr1(ii_to_1),j_tr1(ii_to_1), $
                         i_tr2(ii_from_2),j_tr2(ii_from_2),i_tr2(ii_to_2),j_tr2(ii_to_2),i_inter,j_inter)
;   print,ii_from_1,ii_to_1,ii_from_2,ii_to_2,inter
;   print,i_from_1,j_from_1,i_to_1,j_to_1
;   print,i_from_2,j_from_2,i_to_2,j_to_2
    IF inter NE 0 THEN BEGIN
;      print,'ijinter',i_inter,j_inter
      ipol(count)=i_inter & jpol(count)=j_inter & count=count+1
      IF count EQ 2*Ntr THEN goto,found_all
    ENDIF
  ENDFOR
ENDFOR

found_all:

;=== add points inside
IF count12 NE 0 THEN BEGIN
  ipol(count:count+count12-1)=i_tr1(ind12) & jpol(count:count+count12-1)=j_tr1(ind12) & count=count+count12
ENDIF
IF count21 NE 0 THEN BEGIN
  ipol(count:count+count21-1)=i_tr2(ind21) & jpol(count:count+count21-1)=j_tr2(ind21) & count=count+count21
ENDIF

;count=ii

IF count NE 0 THEN BEGIN
  ipol=ipol(0:count-1)
  jpol=jpol(0:count-1)
  IF keyword_set(order) THEN BEGIN
    sort_by_phase,ipol,jpol
  ENDIF
ENDIF ELSE BEGIN
  ;message,'No intersection',/info
  return,0
ENDELSE

psm=-6
IF keyword_set(plot_it) THEN BEGIN
;;  IF keyword_set(order) THEN psm=-6 ELSE psm=6
  oplot,[ipol(0:count-1),ipol(0)],[jpol(0:count-1),jpol(0)],color=150,psym=psm
  oplot,[ipol(0)],[jpol(0)],color=20,psym=psm
ENDIF

;print,'ijpol',ipol,jpol
IF count GE 3 THEN res=poly_area(ipol,jpol,double=double) ELSE res=0.

RETURN,res

END
